#include <iostream>
#include <string>
using namespace std;

int zbiri(int duzina,int zbirx,int a[],int k){
    zbirx=0;
    if(k==0){
    for(int i=0;i<duzina;i++){
        zbirx=zbirx+a[i];
    }}else
    {
    k=k-1;
    for(int i=0;i<duzina;i++)
    {
        for(int j=i;j<duzina;j++)
        {
            int b[j],dug=0;
            for (int c=i; c<=j; c++)
            {
                b[dug]=a[c];
                dug++;
            }
            zbirx=zbirx+zbiri(dug,zbirx,b,k);
        }
    }}
    return zbirx;
}

int main()
{
    int zbir=0;
    int zbir1=0;
    int a,k;
    int niz[a];
    int m = 1000000007;
    cin>>a>>k;
   for(long long i=0;i<a;i++)
    {
        cin>>niz[i];
    }
    zbir1=zbiri(a,zbir,niz,k);
    cout<<zbir1 % m;
    return 0;
}